Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs	(revision 17464)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.Designer.cs	(revision 17471)
@@ -26,23 +26,15 @@
       this.components = new System.ComponentModel.Container();
       this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.textBoxName = new System.Windows.Forms.TextBox();
       this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
-      this.panel4 = new System.Windows.Forms.Panel();
-      this.textBoxActualName = new System.Windows.Forms.TextBox();
-      this.labelActualName = new System.Windows.Forms.Label();
-      this.panel2 = new System.Windows.Forms.Panel();
       this.labelDescription = new System.Windows.Forms.Label();
       this.textBoxDescription = new System.Windows.Forms.TextBox();
-      this.panel1 = new System.Windows.Forms.Panel();
-      this.textBoxName = new System.Windows.Forms.TextBox();
       this.label1 = new System.Windows.Forms.Label();
-      this.panel3 = new System.Windows.Forms.Panel();
       this.labelEnable = new System.Windows.Forms.Label();
       this.checkBoxActive = new System.Windows.Forms.CheckBox();
+      this.tableLayoutPanel5 = new System.Windows.Forms.TableLayoutPanel();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tableLayoutPanel1.SuspendLayout();
-      this.panel4.SuspendLayout();
-      this.panel2.SuspendLayout();
-      this.panel1.SuspendLayout();
-      this.panel3.SuspendLayout();
+      this.tableLayoutPanel5.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -52,146 +44,110 @@
       this.errorProvider.ContainerControl = this;
       // 
+      // textBoxName
+      // 
+      this.textBoxName.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.errorProvider.SetIconAlignment(this.textBoxName, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.textBoxName.Location = new System.Drawing.Point(100, 24);
+      this.textBoxName.Margin = new System.Windows.Forms.Padding(0);
+      this.textBoxName.Name = "textBoxName";
+      this.textBoxName.Size = new System.Drawing.Size(394, 20);
+      this.textBoxName.TabIndex = 10;
+      this.textBoxName.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxName_Validating);
+      // 
       // tableLayoutPanel1
       // 
       this.tableLayoutPanel1.ColumnCount = 1;
       this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.tableLayoutPanel1.Controls.Add(this.panel4, 0, 3);
-      this.tableLayoutPanel1.Controls.Add(this.panel2, 0, 2);
-      this.tableLayoutPanel1.Controls.Add(this.panel1, 0, 1);
-      this.tableLayoutPanel1.Controls.Add(this.panel3, 0, 0);
+      this.tableLayoutPanel1.Controls.Add(this.tableLayoutPanel5, 0, 0);
       this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
       this.tableLayoutPanel1.Location = new System.Drawing.Point(3, 3);
       this.tableLayoutPanel1.Margin = new System.Windows.Forms.Padding(0);
       this.tableLayoutPanel1.Name = "tableLayoutPanel1";
-      this.tableLayoutPanel1.RowCount = 5;
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25F));
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25F));
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25F));
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 25F));
-      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel1.Size = new System.Drawing.Size(494, 388);
+      this.tableLayoutPanel1.RowCount = 2;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 75F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(494, 594);
       this.tableLayoutPanel1.TabIndex = 16;
-      // 
-      // panel4
-      // 
-      this.panel4.Controls.Add(this.textBoxActualName);
-      this.panel4.Controls.Add(this.labelActualName);
-      this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel4.Location = new System.Drawing.Point(0, 75);
-      this.panel4.Margin = new System.Windows.Forms.Padding(0);
-      this.panel4.Name = "panel4";
-      this.panel4.Size = new System.Drawing.Size(494, 25);
-      this.panel4.TabIndex = 17;
-      // 
-      // textBoxActualName
-      // 
-      this.textBoxActualName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.textBoxActualName.Location = new System.Drawing.Point(92, 3);
-      this.textBoxActualName.Name = "textBoxActualName";
-      this.textBoxActualName.Size = new System.Drawing.Size(396, 20);
-      this.textBoxActualName.TabIndex = 12;
-      // 
-      // labelActualName
-      // 
-      this.labelActualName.AutoSize = true;
-      this.labelActualName.Location = new System.Drawing.Point(6, 6);
-      this.labelActualName.Name = "labelActualName";
-      this.labelActualName.Size = new System.Drawing.Size(65, 13);
-      this.labelActualName.TabIndex = 11;
-      this.labelActualName.Text = "ActualName";
-      this.labelActualName.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
-      // 
-      // panel2
-      // 
-      this.panel2.Controls.Add(this.labelDescription);
-      this.panel2.Controls.Add(this.textBoxDescription);
-      this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel2.Location = new System.Drawing.Point(0, 50);
-      this.panel2.Margin = new System.Windows.Forms.Padding(0);
-      this.panel2.Name = "panel2";
-      this.panel2.Size = new System.Drawing.Size(494, 25);
-      this.panel2.TabIndex = 17;
       // 
       // labelDescription
       // 
       this.labelDescription.AutoSize = true;
-      this.labelDescription.Location = new System.Drawing.Point(6, 6);
+      this.labelDescription.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.labelDescription.Location = new System.Drawing.Point(0, 48);
+      this.labelDescription.Margin = new System.Windows.Forms.Padding(0);
       this.labelDescription.Name = "labelDescription";
-      this.labelDescription.Size = new System.Drawing.Size(60, 13);
+      this.labelDescription.Size = new System.Drawing.Size(100, 27);
       this.labelDescription.TabIndex = 13;
       this.labelDescription.Text = "Description";
+      this.labelDescription.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
       // textBoxDescription
       // 
-      this.textBoxDescription.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.textBoxDescription.Location = new System.Drawing.Point(92, 3);
+      this.textBoxDescription.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.textBoxDescription.Location = new System.Drawing.Point(100, 50);
+      this.textBoxDescription.Margin = new System.Windows.Forms.Padding(0, 2, 0, 0);
       this.textBoxDescription.Name = "textBoxDescription";
-      this.textBoxDescription.Size = new System.Drawing.Size(396, 20);
+      this.textBoxDescription.Size = new System.Drawing.Size(394, 20);
       this.textBoxDescription.TabIndex = 14;
-      // 
-      // panel1
-      // 
-      this.panel1.Controls.Add(this.textBoxName);
-      this.panel1.Controls.Add(this.label1);
-      this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel1.Location = new System.Drawing.Point(0, 25);
-      this.panel1.Margin = new System.Windows.Forms.Padding(0);
-      this.panel1.Name = "panel1";
-      this.panel1.Size = new System.Drawing.Size(494, 25);
-      this.panel1.TabIndex = 17;
-      // 
-      // textBoxName
-      // 
-      this.textBoxName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.textBoxName, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.textBoxName.Location = new System.Drawing.Point(92, 3);
-      this.textBoxName.Name = "textBoxName";
-      this.textBoxName.Size = new System.Drawing.Size(396, 20);
-      this.textBoxName.TabIndex = 10;
-      this.textBoxName.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxName_Validating);
       // 
       // label1
       // 
       this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(6, 6);
+      this.label1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.label1.Location = new System.Drawing.Point(0, 24);
+      this.label1.Margin = new System.Windows.Forms.Padding(0);
       this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(35, 13);
+      this.label1.Size = new System.Drawing.Size(100, 24);
       this.label1.TabIndex = 9;
       this.label1.Text = "Name";
-      this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
-      // 
-      // panel3
-      // 
-      this.panel3.Controls.Add(this.labelEnable);
-      this.panel3.Controls.Add(this.checkBoxActive);
-      this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel3.Location = new System.Drawing.Point(0, 0);
-      this.panel3.Margin = new System.Windows.Forms.Padding(0);
-      this.panel3.Name = "panel3";
-      this.panel3.Size = new System.Drawing.Size(494, 25);
-      this.panel3.TabIndex = 17;
+      this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
       // labelEnable
       // 
-      this.labelEnable.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.labelEnable.AutoSize = true;
-      this.labelEnable.Location = new System.Drawing.Point(6, 7);
+      this.labelEnable.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.labelEnable.Location = new System.Drawing.Point(0, 0);
+      this.labelEnable.Margin = new System.Windows.Forms.Padding(0);
       this.labelEnable.Name = "labelEnable";
-      this.labelEnable.Size = new System.Drawing.Size(40, 13);
+      this.labelEnable.Size = new System.Drawing.Size(100, 24);
       this.labelEnable.TabIndex = 3;
       this.labelEnable.Text = "Enable";
+      this.labelEnable.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
       // checkBoxActive
       // 
       this.checkBoxActive.AutoSize = true;
-      this.checkBoxActive.Location = new System.Drawing.Point(92, 7);
+      this.checkBoxActive.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxActive.Location = new System.Drawing.Point(100, 0);
+      this.checkBoxActive.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxActive.Name = "checkBoxActive";
-      this.checkBoxActive.Size = new System.Drawing.Size(15, 14);
+      this.checkBoxActive.Size = new System.Drawing.Size(394, 24);
       this.checkBoxActive.TabIndex = 2;
       this.checkBoxActive.UseVisualStyleBackColor = true;
+      // 
+      // tableLayoutPanel5
+      // 
+      this.tableLayoutPanel5.ColumnCount = 2;
+      this.tableLayoutPanel5.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 100F));
+      this.tableLayoutPanel5.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel5.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel5.Controls.Add(this.textBoxDescription, 1, 2);
+      this.tableLayoutPanel5.Controls.Add(this.textBoxName, 1, 1);
+      this.tableLayoutPanel5.Controls.Add(this.checkBoxActive, 1, 0);
+      this.tableLayoutPanel5.Controls.Add(this.label1, 0, 1);
+      this.tableLayoutPanel5.Controls.Add(this.labelDescription, 0, 2);
+      this.tableLayoutPanel5.Controls.Add(this.labelEnable, 0, 0);
+      this.tableLayoutPanel5.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel5.Location = new System.Drawing.Point(0, 0);
+      this.tableLayoutPanel5.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel5.Name = "tableLayoutPanel5";
+      this.tableLayoutPanel5.RowCount = 3;
+      this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333F));
+      this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333F));
+      this.tableLayoutPanel5.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 33.33333F));
+      this.tableLayoutPanel5.Size = new System.Drawing.Size(494, 75);
+      this.tableLayoutPanel5.TabIndex = 17;
       // 
       // JsonItemBaseControl
@@ -203,15 +159,9 @@
       this.Name = "JsonItemBaseControl";
       this.Padding = new System.Windows.Forms.Padding(3);
-      this.Size = new System.Drawing.Size(500, 394);
+      this.Size = new System.Drawing.Size(500, 600);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.tableLayoutPanel1.ResumeLayout(false);
-      this.panel4.ResumeLayout(false);
-      this.panel4.PerformLayout();
-      this.panel2.ResumeLayout(false);
-      this.panel2.PerformLayout();
-      this.panel1.ResumeLayout(false);
-      this.panel1.PerformLayout();
-      this.panel3.ResumeLayout(false);
-      this.panel3.PerformLayout();
+      this.tableLayoutPanel5.ResumeLayout(false);
+      this.tableLayoutPanel5.PerformLayout();
       this.ResumeLayout(false);
 
@@ -222,15 +172,10 @@
     protected System.Windows.Forms.Label labelEnable;
     protected System.Windows.Forms.CheckBox checkBoxActive;
-    protected System.Windows.Forms.TextBox textBoxActualName;
-    protected System.Windows.Forms.Label labelActualName;
     protected System.Windows.Forms.TextBox textBoxName;
     protected System.Windows.Forms.Label label1;
     protected System.Windows.Forms.Label labelDescription;
     protected System.Windows.Forms.TextBox textBoxDescription;
-    private System.Windows.Forms.Panel panel1;
-    private System.Windows.Forms.Panel panel3;
-    private System.Windows.Forms.Panel panel2;
-    private System.Windows.Forms.Panel panel4;
     protected System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel5;
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs	(revision 17464)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/JsonItemBaseControl.cs	(revision 17471)
@@ -26,5 +26,6 @@
       InitializeComponent();
       VM = vm;
-      tableLayoutPanel1.Controls.Add(control, 0, 4);
+      control.Margin = new Padding() { All = 0 };
+      tableLayoutPanel1.Controls.Add(control, 0, 1);
       control.Dock = DockStyle.Fill;
       Init();
@@ -36,13 +37,4 @@
       textBoxName.DataBindings.Add("Text", VM, nameof(IJsonItemVM.Name));
       textBoxDescription.DataBindings.Add("Text", VM, nameof(IJsonItemVM.Description));
-      textBoxActualName.DataBindings.Add("Text", VM, nameof(IJsonItemVM.ActualName));
-
-      if (string.IsNullOrWhiteSpace(VM.Item.ActualName)) {
-        textBoxActualName.Enabled = false;
-        tableLayoutPanel1.Controls.Remove(panel4);
-        tableLayoutPanel1.RowStyles[3].Height = 0;
-        //textBoxActualName.ReadOnly = true;
-      } else
-        textBoxActualName.Text = VM.Item.ActualName;
     }
 
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs	(revision 17464)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/NumericRangeControl.Designer.cs	(revision 17471)
@@ -25,36 +25,24 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      this.textBoxFrom = new System.Windows.Forms.TextBox();
       this.groupBox2 = new System.Windows.Forms.GroupBox();
       this.checkBoxTo = new System.Windows.Forms.CheckBox();
       this.textBoxTo = new System.Windows.Forms.TextBox();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.textBoxFrom = new System.Windows.Forms.TextBox();
       this.checkBoxFrom = new System.Windows.Forms.CheckBox();
-      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
       this.groupBox2.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.tableLayoutPanel2.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // textBoxFrom
-      // 
-      this.textBoxFrom.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.textBoxFrom, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-      this.textBoxFrom.Location = new System.Drawing.Point(87, 16);
-      this.textBoxFrom.Name = "textBoxFrom";
-      this.textBoxFrom.ReadOnly = true;
-      this.textBoxFrom.Size = new System.Drawing.Size(407, 20);
-      this.textBoxFrom.TabIndex = 2;
-      this.textBoxFrom.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxFrom_Validating);
       // 
       // groupBox2
       // 
-      this.groupBox2.Controls.Add(this.checkBoxTo);
-      this.groupBox2.Controls.Add(this.textBoxTo);
-      this.groupBox2.Controls.Add(this.checkBoxFrom);
-      this.groupBox2.Controls.Add(this.textBoxFrom);
+      this.groupBox2.Controls.Add(this.tableLayoutPanel2);
       this.groupBox2.Dock = System.Windows.Forms.DockStyle.Fill;
       this.groupBox2.Location = new System.Drawing.Point(0, 0);
+      this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
       this.groupBox2.Name = "groupBox2";
-      this.groupBox2.Size = new System.Drawing.Size(500, 75);
+      this.groupBox2.Size = new System.Drawing.Size(526, 63);
       this.groupBox2.TabIndex = 19;
       this.groupBox2.TabStop = false;
@@ -64,7 +52,9 @@
       // 
       this.checkBoxTo.AutoSize = true;
-      this.checkBoxTo.Location = new System.Drawing.Point(9, 45);
+      this.checkBoxTo.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxTo.Location = new System.Drawing.Point(0, 22);
+      this.checkBoxTo.Margin = new System.Windows.Forms.Padding(0);
       this.checkBoxTo.Name = "checkBoxTo";
-      this.checkBoxTo.Size = new System.Drawing.Size(42, 17);
+      this.checkBoxTo.Size = new System.Drawing.Size(100, 22);
       this.checkBoxTo.TabIndex = 7;
       this.checkBoxTo.Text = "To:";
@@ -73,23 +63,13 @@
       // textBoxTo
       // 
-      this.textBoxTo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.errorProvider.SetIconAlignment(this.textBoxTo, System.Windows.Forms.ErrorIconAlignment.TopLeft);
-      this.textBoxTo.Location = new System.Drawing.Point(87, 42);
+      this.textBoxTo.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.errorProvider.SetIconAlignment(this.textBoxTo, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.textBoxTo.Location = new System.Drawing.Point(100, 22);
+      this.textBoxTo.Margin = new System.Windows.Forms.Padding(0);
       this.textBoxTo.Name = "textBoxTo";
       this.textBoxTo.ReadOnly = true;
-      this.textBoxTo.Size = new System.Drawing.Size(407, 20);
+      this.textBoxTo.Size = new System.Drawing.Size(420, 20);
       this.textBoxTo.TabIndex = 6;
       this.textBoxTo.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxTo_Validating);
-      // 
-      // checkBoxFrom
-      // 
-      this.checkBoxFrom.AutoSize = true;
-      this.checkBoxFrom.Location = new System.Drawing.Point(9, 19);
-      this.checkBoxFrom.Name = "checkBoxFrom";
-      this.checkBoxFrom.Size = new System.Drawing.Size(52, 17);
-      this.checkBoxFrom.TabIndex = 4;
-      this.checkBoxFrom.Text = "From:";
-      this.checkBoxFrom.UseVisualStyleBackColor = true;
       // 
       // errorProvider
@@ -97,4 +77,47 @@
       this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
       this.errorProvider.ContainerControl = this;
+      // 
+      // textBoxFrom
+      // 
+      this.textBoxFrom.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.errorProvider.SetIconAlignment(this.textBoxFrom, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.textBoxFrom.Location = new System.Drawing.Point(100, 0);
+      this.textBoxFrom.Margin = new System.Windows.Forms.Padding(0);
+      this.textBoxFrom.Name = "textBoxFrom";
+      this.textBoxFrom.ReadOnly = true;
+      this.textBoxFrom.Size = new System.Drawing.Size(420, 20);
+      this.textBoxFrom.TabIndex = 2;
+      this.textBoxFrom.Validating += new System.ComponentModel.CancelEventHandler(this.textBoxFrom_Validating);
+      // 
+      // checkBoxFrom
+      // 
+      this.checkBoxFrom.AutoSize = true;
+      this.checkBoxFrom.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.checkBoxFrom.Location = new System.Drawing.Point(0, 0);
+      this.checkBoxFrom.Margin = new System.Windows.Forms.Padding(0);
+      this.checkBoxFrom.Name = "checkBoxFrom";
+      this.checkBoxFrom.Size = new System.Drawing.Size(100, 22);
+      this.checkBoxFrom.TabIndex = 4;
+      this.checkBoxFrom.Text = "From:";
+      this.checkBoxFrom.UseVisualStyleBackColor = true;
+      // 
+      // tableLayoutPanel2
+      // 
+      this.tableLayoutPanel2.ColumnCount = 2;
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 100F));
+      this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel2.Controls.Add(this.textBoxTo, 1, 1);
+      this.tableLayoutPanel2.Controls.Add(this.textBoxFrom, 1, 0);
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxFrom, 0, 0);
+      this.tableLayoutPanel2.Controls.Add(this.checkBoxTo, 0, 1);
+      this.tableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel2.Location = new System.Drawing.Point(3, 16);
+      this.tableLayoutPanel2.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel2.Name = "tableLayoutPanel2";
+      this.tableLayoutPanel2.RowCount = 2;
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel2.Size = new System.Drawing.Size(520, 44);
+      this.tableLayoutPanel2.TabIndex = 22;
       // 
       // NumericRangeControl
@@ -104,8 +127,9 @@
       this.Controls.Add(this.groupBox2);
       this.Name = "NumericRangeControl";
-      this.Size = new System.Drawing.Size(500, 75);
+      this.Size = new System.Drawing.Size(526, 63);
       this.groupBox2.ResumeLayout(false);
-      this.groupBox2.PerformLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.tableLayoutPanel2.ResumeLayout(false);
+      this.tableLayoutPanel2.PerformLayout();
       this.ResumeLayout(false);
 
@@ -113,10 +137,11 @@
 
     #endregion
-    private System.Windows.Forms.TextBox textBoxFrom;
     private System.Windows.Forms.GroupBox groupBox2;
     private System.Windows.Forms.CheckBox checkBoxTo;
     private System.Windows.Forms.TextBox textBoxTo;
+    private System.Windows.Forms.ErrorProvider errorProvider;
     private System.Windows.Forms.CheckBox checkBoxFrom;
-    private System.Windows.Forms.ErrorProvider errorProvider;
+    private System.Windows.Forms.TextBox textBoxFrom;
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel2;
   }
 }